package org.apache.tomcat.util.http;

package ..deTemp.1736038829724;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public final class FastHttpDateFormat {
  public static String getCurrentDate() {
    long now = System.currentTimeMillis();
    if (Math.abs(now - currentDateGenerated) > 1000L) {
      currentDate = FORMAT_RFC5322.format(new Date(now));
      currentDateGenerated = now;
    } 
    return currentDate;
  }
  
  @Deprecated
  public static String formatDate(long value, DateFormat threadLocalformat) {
    return formatDate(value);
  }
  
  public static String formatDate(long value) {
    Long longValue = Long.valueOf(value);
    String cachedDate = formatCache.get(longValue);
    if (cachedDate != null)
      return cachedDate; 
    String newDate = FORMAT_RFC5322.format(new Date(value));
    updateFormatCache(longValue, newDate);
    return newDate;
  }
  
  @Deprecated
  public static long parseDate(String value, DateFormat[] threadLocalformats) {
    return parseDate(value);
  }
  
  public static long parseDate(String value) {
    Long cachedDate = parseCache.get(value);
    if (cachedDate != null)
      return cachedDate.longValue(); 
    long date = -1L;
    for (int i = 0; date == -1L && i < httpParseFormats.length; i++) {
      try {
        date = httpParseFormats[i].parse(value).getTime();
        updateParseCache(value, Long.valueOf(date));
      } catch (ParseException parseException) {}
    } 
    return date;
  }
  
  private static void updateFormatCache(Long key, String value) {
    if (value == null)
      return; 
    if (formatCache.size() > CACHE_SIZE)
      formatCache.clear(); 
    formatCache.put(key, value);
  }
  
  private static void updateParseCache(String key, Long value) {
    if (value == null)
      return; 
    if (parseCache.size() > CACHE_SIZE)
      parseCache.clear(); 
    parseCache.put(key, value);
  }
  
  private static final int CACHE_SIZE = Integer.getInteger("org.apache.tomcat.util.http.FastHttpDateFormat.CACHE_SIZE", 1000).intValue();
  
  @Deprecated
  public static final String RFC1123_DATE = "EEE, dd MMM yyyy HH:mm:ss zzz";
  
  private static final String DATE_RFC5322 = "EEE, dd MMM yyyy HH:mm:ss z";
  
  private static final String DATE_OBSOLETE_RFC850 = "EEEEEE, dd-MMM-yy HH:mm:ss zzz";
  
  private static final String DATE_OBSOLETE_ASCTIME = "EEE MMMM d HH:mm:ss yyyy";
  
  private static final SimpleDateFormat FORMAT_RFC5322;
  
  private static final SimpleDateFormat FORMAT_OBSOLETE_RFC850;
  
  private static final SimpleDateFormat FORMAT_OBSOLETE_ASCTIME;
  
  static {
    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");
    FORMAT_RFC5322 = sdf;
    FORMAT_OBSOLETE_RFC850 = sdf;
    FORMAT_OBSOLETE_ASCTIME = sdf;
  }
  
  private static final SimpleDateFormat[] httpParseFormats = new SimpleDateFormat[] { FORMAT_RFC5322, FORMAT_OBSOLETE_RFC850, FORMAT_OBSOLETE_ASCTIME };
  
  private static volatile long currentDateGenerated = 0L;
  
  private static String currentDate = null;
  
  private static final Map<Long, String> formatCache = new ConcurrentHashMap<>(CACHE_SIZE);
  
  private static final Map<String, Long> parseCache = new ConcurrentHashMap<>(CACHE_SIZE);
}
